(function (win, doc) {
    var obj = {
        language: win.navigator.userLanguage || win.navigator.language,
        label: {
            accept: "Yes, I accept",
            modify: "Cookies statement",
            more: "More information about ERA's cookies policy",
            cookies: "Cookies",
            uses_cookies: "This site uses cookies to offer you a better browsing experience. Find out more on how we use cookies by clicking <strong>\"Cookies statement\"</strong>. By clicking <strong>\"Yes, I accept\"</strong>, you agree on using all cookies",
            cookieDetailsTitle: "Cookies statement",
            cookieDetailsText1: "<p>A cookie is a small piece of text that a website stores on the browser in your computer or mobile device when you visit it.</p>" +
                "<p>ERA SRM Portal uses <b>\"first-party cookies\"</b>. These are cookies set and controlled by ERA, not by any external organisation. " +
                "ERA SRM Portal is not using <b>third-party cookies</b></p>" +
                "<p><b>First-party cookies we use are to:</b></p>" +
                "<ul>" +
                "<li>store visitor preferences (cookies consent)</li>" +
                "<li>make our websites operational</li>" +
                "<li>gather analytics data (about user behaviour), if accepted</li>" +
                "</ul>" +
				"<p>All cookies used by the ERA SRM Portal are required to maintain the functionality of the application, with the purpose as described in the table below.</p>",
            cookieDetailsText2: "<p>Cookies with the <i>session</i> lifetime are only used while the browser is open, and removed after you close the browser.</p>" +
				"<p>The cookies in the portal are not storing any personal data, nor your IP address</p>" +
				"For any queries in relation to our policy on cookies and your choices, please <a target='_blanck' href=''>contact us</a>.",
            contact: ""
        },
        showBanner: function () {
			var cb = document.createElement("div");
            cb.id = "cookie-consent-banner";
            cb.className = "cookie-consent-banner";
            var inner_html = '<h2>' + obj.label.cookies + '</h2>';
            inner_html += '<p class="cookie-consent-inform">' + obj.label.uses_cookies + ". ";
            inner_html += "<div class='cookie-consent-actions' style='margin-right: 20px;'><a style=\"color:#fff\" href=\"javascript:euCookieConsent.accept()\">" + obj.label.accept + "</a></div>";
            inner_html += "<div class='cookie-consent-actions'><a style=\"color:#fff\" href=\"javascript:euCookieConsent.openModal()\">" + obj.label.modify + "</a></div>";
            cb.innerHTML = inner_html;

            var body = document.getElementsByTagName('body')[0];
            body.insertBefore(cb, body.childNodes[0]);
        },
        openModal: function () {
            var language = win.navigator.userLanguage || win.navigator.language;
            var body = document.getElementsByTagName('body')[0];
            var modal = document.createElement("div");
            modal.id = "cookie-details";
            modal.className = "cookies-details";
            var modalContent = document.createElement("div");
            modalContent.id = "cookies";
            modalContent.className = "cookies";

            modalContent.innerHTML += '<a href="javascript:euCookieConsent.closeModal()" class="close">Close</a><h3>' + obj.label.cookieDetailsTitle + '</h3>';
            modalContent.innerHTML += obj.label.cookieDetailsText1;
            modalContent.innerHTML += '<table><tr><th>Name</th><th>Domain</th><th>Purpose</th><th>Type and duration</th></tr><tr><td>ASP.NET_SessionId</td><td>' + 
				window.location.hostname + '</td><td>Preserves user session state across page requests</td><td>Session, deleted after you quit your browser</td></tr><tr><td>adx-notification</td><td>' + 
				window.location.hostname + '</td><td>Used in basic form actions to store alert message to be shown on redirection.</td><td>Session, deleted after you quit your browser</td></tr><tr><td>cookie-consent</td><td>' + 
				window.location.hostname + '</td><td>Stores the user\'s cookie consent state for the current domain</td > <td>1 month</td> </tr > <tr><td>__RequestVerificationToken</td><td>' +
                window.location.hostname + '</td><td>Anti-forgery token</td><td>Session, deleted after you quit your browser</td></tr><tr><td>isDSTObserved</td><td>' +
                window.location.hostname + '</td><td>Stores a value to indicate if the current moment is in daylight saving time.</td><td>Session, deleted after you quit your browser</td></tr><tr><td>isDSTSupport</td><td>' +
                window.location.hostname + '</td><td>Indicates whether a specified date and time falls in the range of daylight saving time.</td><td>Session , deleted after you quit your browser</td></tr><tr><td>timeZoneCode</td><td>' +
                window.location.hostname + '</td><td>Stores the timezonecode field value of Potrtal timezonedefinition table for the current timezone.</td><td>Session, deleted after you quit your browser</td></tr><tr><td>timezoneoffset</td><td>' +
                window.location.hostname + '</td><td>Stores the timezone difference between UTC and Local browser time.</td><td>Session, deleted after you quit your browser</td></tr> <tr><td>.AspNet.ApplicationCookie</td><td>' +
                window.location.hostname + '</td><td>Used to determine if a user is authenticated</td><td>Session, deleted after you signout</td></tr> <tr><td>ARRAffinity</td><td>' +
                window.location.hostname + '</td><td>Added automatically by Azure websites and ensures that requests are load balanced between different sites.</td><td>Session, deleted after you quit your browser</td></tr><tr><td>Dynamics365PortalAnalytics</td><td>' +
                window.location.hostname + '</td><td>Critical service cookie to analyze service usage anonymously and aggregated for statistical purpose.</td><td>90 days</td></tr><tr><td>ContextLanguageCode</td><td>' +
                window.location.hostname + '</td><td>Stores the default language of the user accessing portal within a session and across webpages.</td><td>Session, deleted after you quit your browser</td></tr></table>'
            modalContent.innerHTML += obj.label.cookieDetailsText2;
            modalContent.innerHTML += '<div style=\"text-align: right\"><a href="javascript:euCookieConsent.closeModal()" class="close">Close</a></div>';
            modal.insertBefore(modalContent, modal.childNodes[0]);
            body.insertBefore(modal, body.childNodes[0]);
        },
        closeModal: function () {
            var modal = document.getElementById("cookie-details");
            modal.parentNode.removeChild(modal);
        },
        accept: function () {
            var h = win.location.host;
            h = (h.match(/srm-portal\.powerappsportals\.com/)) ? window.location.hostname : null;
            var d = new Date();
            d.setTime(d.getTime() + (30 * 24 * 60 * 60 * 1000));
            doc.cookie = "cookie-consent=accept;secure;samesite=lax;path=/" + ";expires=" + d.toUTCString() + ((h == null) ? "" : "; domain=" + h);
            location.reload();
        },
        init: function () {
            if (document.cookie.indexOf("cookie-consent") < 0) {
                var body = document.getElementsByTagName('body')[0];
                if (typeof body !== "undefined") {
                    obj.showBanner();
                } else if (document.addEventListener) {
                    document.addEventListener("DOMContentLoaded", obj.showBanner, false);
                } else if (document.attachEvent) {
                    document.attachEvent("onreadystatechange", function () {
                        if (/loaded|complete/.test(document.readyState)) obj.showBanner();
                    })
                }
            }
        }
    }

    obj.init();
    win.euCookieConsent = {};
    win.euCookieConsent.accept = obj.accept;
    win.euCookieConsent.openModal = obj.openModal;
    win.euCookieConsent.closeModal = obj.closeModal;


})(window, document);